require = GLOBAL.require
STRINGS=GLOBAL.STRINGS
Vector3=GLOBAL.Vector3
PI=GLOBAL.PI

Assets = {
    Asset( "ATLAS", "images/inventoryimages/bigmushroom.xml" ),
    Asset( "IMAGE", "images/inventoryimages/bigmushroom.tex" ),
}

PrefabFiles = {
"bigmushroom",
"smallmushroom",
}

local Eater = require "components/eater"
local myeater = Eater.CanEat
function Eater:CanEat(inst)
	local asdf = myeater(self, inst)
    if inst and inst.components.edible and self.foodprefs then
        for k,v in pairs(self.foodprefs) do
            if inst.prefab == "bigmushroom" or inst.prefab == "smallmushroom" then
                return true
            end
        end
    end
	return asdf
end

STRINGS.NAMES.BIGMUSHROOM="Super Mushroom"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BIGMUSHROOM = "One makes you larger.\nOne makes you small."
STRINGS.NAMES.SMALLMUSHROOM="Mini Mushroom"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SMALLMUSHROOM = "The ones that mother gives you,\ndon't do anything at all."

--[[
local function meatorveg(inst)
	inst:DoPeriodicTask(0, function(inst)
		if TheWorld.prefab == "cave" then --FIXME
			inst.components.edible.foodtype = "VEGGIE"
		else
			inst.components.edible.foodtype = "MEAT"
		end
	end)
end
AddPrefabPostInit("bigmushroom", meatorveg)
AddPrefabPostInit("smallmushroom", meatorveg)
--]]

AddPlayerPostInit(function(inst)
	local time=3*60
	local cooldowntimer=time
	inst:DoPeriodicTask(1, function(inst)
		if cooldowntimer>0 then
			cooldowntimer=cooldowntimer-1
		end
	end)
	inst:ListenForEvent("wormholespit", function(inst)
		if math.random(100)<=5 and cooldowntimer==0 then
			cooldowntimer=time
			spawnshroom(inst)
		end
	end)
	inst:ListenForEvent("working", function(inst)
		if math.random(100)<=5 and cooldowntimer==0 then
			cooldowntimer=time
			spawnshroom(inst)
		end
	end)
	inst:ListenForEvent("buildstructure", function(inst)
		if math.random(100)<=5 and cooldowntimer==0 then
			cooldowntimer=time
			spawnshroom(inst)
		end
	end)
	inst:ListenForEvent("fishingcatch", function(inst)
		if math.random(100)<=5 and cooldowntimer==0 then
			cooldowntimer=time
			spawnshroom(inst)
		end
	end)
	inst:ListenForEvent("locomote", function(inst)
		if math.random(2000)==1 and cooldowntimer==0 then
			cooldowntimer=time
			spawnshroom(inst)
		end
	end)
	inst:ListenForEvent("picksomething", function(inst)
		if math.random(100)<=5 and cooldowntimer==0 then
			cooldowntimer=time
			spawnshroom(inst)
		end
	end)
	inst:ListenForEvent("harvestsomething", function(inst)
		if math.random(100)<=5 and cooldowntimer==0 then
			cooldowntimer=time
			spawnshroom(inst)
		end
	end)
end)

function spawnshroom(inst)
	local prefab
	if math.random(4)==1 then
		prefab="smallmushroom"
	else
		prefab="bigmushroom"
	end
	if prefab then
		fancydropper(inst,prefab)
	end
end

function fancydropper(inst,prefab)
	local pt = Vector3(inst.Transform:GetWorldPosition())
	if prefab then
		local shroom = GLOBAL.c_spawn(prefab,1)
		if shroom then
			local angle = math.random()*2*PI
			shroom.Physics:SetVel(2*math.cos(angle), 10, 2*math.sin(angle))
			pt = pt + Vector3(math.cos(angle), 0, math.sin(angle))*((shroom.Physics:GetRadius() or 1) + (shroom.Physics:GetRadius() or 1))
			shroom.Transform:SetPosition(pt.x,pt.y,pt.z)
		end
	end
end

--some simple debug tools
--[[
GLOBAL.require("debugkeys")
local function keyt(player)
	GLOBAL.TheInput:AddKeyDownHandler(GLOBAL.KEY_T, function(down)
--		ThePlayer.shroomed.time=ThePlayer.shroomed.time+20

--		ThePlayer:PushEvent("bigshroomed")
		GLOBAL.DebugSpawn("bigmushroom")
	end)
end
AddSimPostInit(keyt)
GLOBAL.require("debugkeys")
local function keyr(player)
	GLOBAL.TheInput:AddKeyDownHandler(GLOBAL.KEY_R, function(down)
--		ThePlayer.shroomed.time=ThePlayer.shroomed.time-20
--		ThePlayer:PushEvent("smallshroomed")
		GLOBAL.DebugSpawn("smallmushroom")
	end)
end
AddSimPostInit(keyr)
--]]
